/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the ManagedResource type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ManagedResource{}

// ManagedResource struct for ManagedResource
type ManagedResource struct {
	JsonSchemaId        *string           `json:"jsonSchemaId,omitempty"`
	AdministratorsId    NullableString    `json:"administratorsId,omitempty"`
	ResourceIdentifier  string            `json:"resourceIdentifier"`
	DisplayName         string            `json:"displayName"`
	Description         NullableString    `json:"description,omitempty"`
	ManagedResourceType string            `json:"managedResourceType"`
	Owner               *Identity         `json:"owner,omitempty"`
	Administrators      *Group            `json:"administrators,omitempty"`
	ResourceCategory    *ResourceCategory `json:"resourceCategory,omitempty"`
	Reassignable        *bool             `json:"reassignable,omitempty"`
	AutoReassign        *bool             `json:"autoReassign,omitempty"`
	// Deprecated
	PendingAction    *bool          `json:"pendingAction,omitempty"`
	Disabled         *bool          `json:"disabled,omitempty"`
	Blocked          *bool          `json:"blocked,omitempty"`
	SecurityIssues   *bool          `json:"securityIssues,omitempty"`
	BlockingReason   NullableString `json:"blockingReason,omitempty"`
	BlockingTime     NullableTime   `json:"blockingTime,omitempty"`
	BlockingDeadline NullableTime   `json:"blockingDeadline,omitempty"`
	ArchiveDeadline  NullableTime   `json:"archiveDeadline,omitempty"`
	DeleteDeadline   NullableTime   `json:"deleteDeadline,omitempty"`
	// Deprecated
	ExpirationDeadline  NullableTime   `json:"expirationDeadline,omitempty"`
	OwnerId             NullableString `json:"ownerId,omitempty"`
	InternalState       *ResourceState `json:"internalState,omitempty"`
	State               *ResourceState `json:"state,omitempty"`
	LastStateChangeTime NullableTime   `json:"lastStateChangeTime,omitempty"`
	ValidityLimit       NullableTime   `json:"validityLimit,omitempty"`
	Id                  NullableString `json:"id,omitempty"`
	CreationTime        *time.Time     `json:"creationTime,omitempty"`
}

type _ManagedResource ManagedResource

// NewManagedResource instantiates a new ManagedResource object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewManagedResource(resourceIdentifier string, displayName string, managedResourceType string) *ManagedResource {
	this := ManagedResource{}
	this.ResourceIdentifier = resourceIdentifier
	this.DisplayName = displayName
	this.ManagedResourceType = managedResourceType
	return &this
}

// NewManagedResourceWithDefaults instantiates a new ManagedResource object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewManagedResourceWithDefaults() *ManagedResource {
	this := ManagedResource{}
	return &this
}

// GetJsonSchemaId returns the JsonSchemaId field value if set, zero value otherwise.
func (o *ManagedResource) GetJsonSchemaId() string {
	if o == nil || IsNil(o.JsonSchemaId) {
		var ret string
		return ret
	}
	return *o.JsonSchemaId
}

// GetJsonSchemaIdOk returns a tuple with the JsonSchemaId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetJsonSchemaIdOk() (*string, bool) {
	if o == nil || IsNil(o.JsonSchemaId) {
		return nil, false
	}
	return o.JsonSchemaId, true
}

// HasJsonSchemaId returns a boolean if a field has been set.
func (o *ManagedResource) HasJsonSchemaId() bool {
	if o != nil && !IsNil(o.JsonSchemaId) {
		return true
	}

	return false
}

// SetJsonSchemaId gets a reference to the given string and assigns it to the JsonSchemaId field.
func (o *ManagedResource) SetJsonSchemaId(v string) {
	o.JsonSchemaId = &v
}

// GetAdministratorsId returns the AdministratorsId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetAdministratorsId() string {
	if o == nil || IsNil(o.AdministratorsId.Get()) {
		var ret string
		return ret
	}
	return *o.AdministratorsId.Get()
}

// GetAdministratorsIdOk returns a tuple with the AdministratorsId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetAdministratorsIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AdministratorsId.Get(), o.AdministratorsId.IsSet()
}

// HasAdministratorsId returns a boolean if a field has been set.
func (o *ManagedResource) HasAdministratorsId() bool {
	if o != nil && o.AdministratorsId.IsSet() {
		return true
	}

	return false
}

// SetAdministratorsId gets a reference to the given NullableString and assigns it to the AdministratorsId field.
func (o *ManagedResource) SetAdministratorsId(v string) {
	o.AdministratorsId.Set(&v)
}

// SetAdministratorsIdNil sets the value for AdministratorsId to be an explicit nil
func (o *ManagedResource) SetAdministratorsIdNil() {
	o.AdministratorsId.Set(nil)
}

// UnsetAdministratorsId ensures that no value is present for AdministratorsId, not even an explicit nil
func (o *ManagedResource) UnsetAdministratorsId() {
	o.AdministratorsId.Unset()
}

// GetResourceIdentifier returns the ResourceIdentifier field value
func (o *ManagedResource) GetResourceIdentifier() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ResourceIdentifier
}

// GetResourceIdentifierOk returns a tuple with the ResourceIdentifier field value
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetResourceIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ResourceIdentifier, true
}

// SetResourceIdentifier sets field value
func (o *ManagedResource) SetResourceIdentifier(v string) {
	o.ResourceIdentifier = v
}

// GetDisplayName returns the DisplayName field value
func (o *ManagedResource) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *ManagedResource) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *ManagedResource) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *ManagedResource) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *ManagedResource) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *ManagedResource) UnsetDescription() {
	o.Description.Unset()
}

// GetManagedResourceType returns the ManagedResourceType field value
func (o *ManagedResource) GetManagedResourceType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ManagedResourceType
}

// GetManagedResourceTypeOk returns a tuple with the ManagedResourceType field value
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetManagedResourceTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ManagedResourceType, true
}

// SetManagedResourceType sets field value
func (o *ManagedResource) SetManagedResourceType(v string) {
	o.ManagedResourceType = v
}

// GetOwner returns the Owner field value if set, zero value otherwise.
func (o *ManagedResource) GetOwner() Identity {
	if o == nil || IsNil(o.Owner) {
		var ret Identity
		return ret
	}
	return *o.Owner
}

// GetOwnerOk returns a tuple with the Owner field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetOwnerOk() (*Identity, bool) {
	if o == nil || IsNil(o.Owner) {
		return nil, false
	}
	return o.Owner, true
}

// HasOwner returns a boolean if a field has been set.
func (o *ManagedResource) HasOwner() bool {
	if o != nil && !IsNil(o.Owner) {
		return true
	}

	return false
}

// SetOwner gets a reference to the given Identity and assigns it to the Owner field.
func (o *ManagedResource) SetOwner(v Identity) {
	o.Owner = &v
}

// GetAdministrators returns the Administrators field value if set, zero value otherwise.
func (o *ManagedResource) GetAdministrators() Group {
	if o == nil || IsNil(o.Administrators) {
		var ret Group
		return ret
	}
	return *o.Administrators
}

// GetAdministratorsOk returns a tuple with the Administrators field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetAdministratorsOk() (*Group, bool) {
	if o == nil || IsNil(o.Administrators) {
		return nil, false
	}
	return o.Administrators, true
}

// HasAdministrators returns a boolean if a field has been set.
func (o *ManagedResource) HasAdministrators() bool {
	if o != nil && !IsNil(o.Administrators) {
		return true
	}

	return false
}

// SetAdministrators gets a reference to the given Group and assigns it to the Administrators field.
func (o *ManagedResource) SetAdministrators(v Group) {
	o.Administrators = &v
}

// GetResourceCategory returns the ResourceCategory field value if set, zero value otherwise.
func (o *ManagedResource) GetResourceCategory() ResourceCategory {
	if o == nil || IsNil(o.ResourceCategory) {
		var ret ResourceCategory
		return ret
	}
	return *o.ResourceCategory
}

// GetResourceCategoryOk returns a tuple with the ResourceCategory field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetResourceCategoryOk() (*ResourceCategory, bool) {
	if o == nil || IsNil(o.ResourceCategory) {
		return nil, false
	}
	return o.ResourceCategory, true
}

// HasResourceCategory returns a boolean if a field has been set.
func (o *ManagedResource) HasResourceCategory() bool {
	if o != nil && !IsNil(o.ResourceCategory) {
		return true
	}

	return false
}

// SetResourceCategory gets a reference to the given ResourceCategory and assigns it to the ResourceCategory field.
func (o *ManagedResource) SetResourceCategory(v ResourceCategory) {
	o.ResourceCategory = &v
}

// GetReassignable returns the Reassignable field value if set, zero value otherwise.
func (o *ManagedResource) GetReassignable() bool {
	if o == nil || IsNil(o.Reassignable) {
		var ret bool
		return ret
	}
	return *o.Reassignable
}

// GetReassignableOk returns a tuple with the Reassignable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetReassignableOk() (*bool, bool) {
	if o == nil || IsNil(o.Reassignable) {
		return nil, false
	}
	return o.Reassignable, true
}

// HasReassignable returns a boolean if a field has been set.
func (o *ManagedResource) HasReassignable() bool {
	if o != nil && !IsNil(o.Reassignable) {
		return true
	}

	return false
}

// SetReassignable gets a reference to the given bool and assigns it to the Reassignable field.
func (o *ManagedResource) SetReassignable(v bool) {
	o.Reassignable = &v
}

// GetAutoReassign returns the AutoReassign field value if set, zero value otherwise.
func (o *ManagedResource) GetAutoReassign() bool {
	if o == nil || IsNil(o.AutoReassign) {
		var ret bool
		return ret
	}
	return *o.AutoReassign
}

// GetAutoReassignOk returns a tuple with the AutoReassign field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetAutoReassignOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoReassign) {
		return nil, false
	}
	return o.AutoReassign, true
}

// HasAutoReassign returns a boolean if a field has been set.
func (o *ManagedResource) HasAutoReassign() bool {
	if o != nil && !IsNil(o.AutoReassign) {
		return true
	}

	return false
}

// SetAutoReassign gets a reference to the given bool and assigns it to the AutoReassign field.
func (o *ManagedResource) SetAutoReassign(v bool) {
	o.AutoReassign = &v
}

// GetPendingAction returns the PendingAction field value if set, zero value otherwise.
// Deprecated
func (o *ManagedResource) GetPendingAction() bool {
	if o == nil || IsNil(o.PendingAction) {
		var ret bool
		return ret
	}
	return *o.PendingAction
}

// GetPendingActionOk returns a tuple with the PendingAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
// Deprecated
func (o *ManagedResource) GetPendingActionOk() (*bool, bool) {
	if o == nil || IsNil(o.PendingAction) {
		return nil, false
	}
	return o.PendingAction, true
}

// HasPendingAction returns a boolean if a field has been set.
func (o *ManagedResource) HasPendingAction() bool {
	if o != nil && !IsNil(o.PendingAction) {
		return true
	}

	return false
}

// SetPendingAction gets a reference to the given bool and assigns it to the PendingAction field.
// Deprecated
func (o *ManagedResource) SetPendingAction(v bool) {
	o.PendingAction = &v
}

// GetDisabled returns the Disabled field value if set, zero value otherwise.
func (o *ManagedResource) GetDisabled() bool {
	if o == nil || IsNil(o.Disabled) {
		var ret bool
		return ret
	}
	return *o.Disabled
}

// GetDisabledOk returns a tuple with the Disabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetDisabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Disabled) {
		return nil, false
	}
	return o.Disabled, true
}

// HasDisabled returns a boolean if a field has been set.
func (o *ManagedResource) HasDisabled() bool {
	if o != nil && !IsNil(o.Disabled) {
		return true
	}

	return false
}

// SetDisabled gets a reference to the given bool and assigns it to the Disabled field.
func (o *ManagedResource) SetDisabled(v bool) {
	o.Disabled = &v
}

// GetBlocked returns the Blocked field value if set, zero value otherwise.
func (o *ManagedResource) GetBlocked() bool {
	if o == nil || IsNil(o.Blocked) {
		var ret bool
		return ret
	}
	return *o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetBlockedOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocked) {
		return nil, false
	}
	return o.Blocked, true
}

// HasBlocked returns a boolean if a field has been set.
func (o *ManagedResource) HasBlocked() bool {
	if o != nil && !IsNil(o.Blocked) {
		return true
	}

	return false
}

// SetBlocked gets a reference to the given bool and assigns it to the Blocked field.
func (o *ManagedResource) SetBlocked(v bool) {
	o.Blocked = &v
}

// GetSecurityIssues returns the SecurityIssues field value if set, zero value otherwise.
func (o *ManagedResource) GetSecurityIssues() bool {
	if o == nil || IsNil(o.SecurityIssues) {
		var ret bool
		return ret
	}
	return *o.SecurityIssues
}

// GetSecurityIssuesOk returns a tuple with the SecurityIssues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetSecurityIssuesOk() (*bool, bool) {
	if o == nil || IsNil(o.SecurityIssues) {
		return nil, false
	}
	return o.SecurityIssues, true
}

// HasSecurityIssues returns a boolean if a field has been set.
func (o *ManagedResource) HasSecurityIssues() bool {
	if o != nil && !IsNil(o.SecurityIssues) {
		return true
	}

	return false
}

// SetSecurityIssues gets a reference to the given bool and assigns it to the SecurityIssues field.
func (o *ManagedResource) SetSecurityIssues(v bool) {
	o.SecurityIssues = &v
}

// GetBlockingReason returns the BlockingReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetBlockingReason() string {
	if o == nil || IsNil(o.BlockingReason.Get()) {
		var ret string
		return ret
	}
	return *o.BlockingReason.Get()
}

// GetBlockingReasonOk returns a tuple with the BlockingReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetBlockingReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingReason.Get(), o.BlockingReason.IsSet()
}

// HasBlockingReason returns a boolean if a field has been set.
func (o *ManagedResource) HasBlockingReason() bool {
	if o != nil && o.BlockingReason.IsSet() {
		return true
	}

	return false
}

// SetBlockingReason gets a reference to the given NullableString and assigns it to the BlockingReason field.
func (o *ManagedResource) SetBlockingReason(v string) {
	o.BlockingReason.Set(&v)
}

// SetBlockingReasonNil sets the value for BlockingReason to be an explicit nil
func (o *ManagedResource) SetBlockingReasonNil() {
	o.BlockingReason.Set(nil)
}

// UnsetBlockingReason ensures that no value is present for BlockingReason, not even an explicit nil
func (o *ManagedResource) UnsetBlockingReason() {
	o.BlockingReason.Unset()
}

// GetBlockingTime returns the BlockingTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetBlockingTime() time.Time {
	if o == nil || IsNil(o.BlockingTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingTime.Get()
}

// GetBlockingTimeOk returns a tuple with the BlockingTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetBlockingTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingTime.Get(), o.BlockingTime.IsSet()
}

// HasBlockingTime returns a boolean if a field has been set.
func (o *ManagedResource) HasBlockingTime() bool {
	if o != nil && o.BlockingTime.IsSet() {
		return true
	}

	return false
}

// SetBlockingTime gets a reference to the given NullableTime and assigns it to the BlockingTime field.
func (o *ManagedResource) SetBlockingTime(v time.Time) {
	o.BlockingTime.Set(&v)
}

// SetBlockingTimeNil sets the value for BlockingTime to be an explicit nil
func (o *ManagedResource) SetBlockingTimeNil() {
	o.BlockingTime.Set(nil)
}

// UnsetBlockingTime ensures that no value is present for BlockingTime, not even an explicit nil
func (o *ManagedResource) UnsetBlockingTime() {
	o.BlockingTime.Unset()
}

// GetBlockingDeadline returns the BlockingDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetBlockingDeadline() time.Time {
	if o == nil || IsNil(o.BlockingDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingDeadline.Get()
}

// GetBlockingDeadlineOk returns a tuple with the BlockingDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetBlockingDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingDeadline.Get(), o.BlockingDeadline.IsSet()
}

// HasBlockingDeadline returns a boolean if a field has been set.
func (o *ManagedResource) HasBlockingDeadline() bool {
	if o != nil && o.BlockingDeadline.IsSet() {
		return true
	}

	return false
}

// SetBlockingDeadline gets a reference to the given NullableTime and assigns it to the BlockingDeadline field.
func (o *ManagedResource) SetBlockingDeadline(v time.Time) {
	o.BlockingDeadline.Set(&v)
}

// SetBlockingDeadlineNil sets the value for BlockingDeadline to be an explicit nil
func (o *ManagedResource) SetBlockingDeadlineNil() {
	o.BlockingDeadline.Set(nil)
}

// UnsetBlockingDeadline ensures that no value is present for BlockingDeadline, not even an explicit nil
func (o *ManagedResource) UnsetBlockingDeadline() {
	o.BlockingDeadline.Unset()
}

// GetArchiveDeadline returns the ArchiveDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetArchiveDeadline() time.Time {
	if o == nil || IsNil(o.ArchiveDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ArchiveDeadline.Get()
}

// GetArchiveDeadlineOk returns a tuple with the ArchiveDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetArchiveDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ArchiveDeadline.Get(), o.ArchiveDeadline.IsSet()
}

// HasArchiveDeadline returns a boolean if a field has been set.
func (o *ManagedResource) HasArchiveDeadline() bool {
	if o != nil && o.ArchiveDeadline.IsSet() {
		return true
	}

	return false
}

// SetArchiveDeadline gets a reference to the given NullableTime and assigns it to the ArchiveDeadline field.
func (o *ManagedResource) SetArchiveDeadline(v time.Time) {
	o.ArchiveDeadline.Set(&v)
}

// SetArchiveDeadlineNil sets the value for ArchiveDeadline to be an explicit nil
func (o *ManagedResource) SetArchiveDeadlineNil() {
	o.ArchiveDeadline.Set(nil)
}

// UnsetArchiveDeadline ensures that no value is present for ArchiveDeadline, not even an explicit nil
func (o *ManagedResource) UnsetArchiveDeadline() {
	o.ArchiveDeadline.Unset()
}

// GetDeleteDeadline returns the DeleteDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetDeleteDeadline() time.Time {
	if o == nil || IsNil(o.DeleteDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.DeleteDeadline.Get()
}

// GetDeleteDeadlineOk returns a tuple with the DeleteDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetDeleteDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeleteDeadline.Get(), o.DeleteDeadline.IsSet()
}

// HasDeleteDeadline returns a boolean if a field has been set.
func (o *ManagedResource) HasDeleteDeadline() bool {
	if o != nil && o.DeleteDeadline.IsSet() {
		return true
	}

	return false
}

// SetDeleteDeadline gets a reference to the given NullableTime and assigns it to the DeleteDeadline field.
func (o *ManagedResource) SetDeleteDeadline(v time.Time) {
	o.DeleteDeadline.Set(&v)
}

// SetDeleteDeadlineNil sets the value for DeleteDeadline to be an explicit nil
func (o *ManagedResource) SetDeleteDeadlineNil() {
	o.DeleteDeadline.Set(nil)
}

// UnsetDeleteDeadline ensures that no value is present for DeleteDeadline, not even an explicit nil
func (o *ManagedResource) UnsetDeleteDeadline() {
	o.DeleteDeadline.Unset()
}

// GetExpirationDeadline returns the ExpirationDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
// Deprecated
func (o *ManagedResource) GetExpirationDeadline() time.Time {
	if o == nil || IsNil(o.ExpirationDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ExpirationDeadline.Get()
}

// GetExpirationDeadlineOk returns a tuple with the ExpirationDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
// Deprecated
func (o *ManagedResource) GetExpirationDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExpirationDeadline.Get(), o.ExpirationDeadline.IsSet()
}

// HasExpirationDeadline returns a boolean if a field has been set.
func (o *ManagedResource) HasExpirationDeadline() bool {
	if o != nil && o.ExpirationDeadline.IsSet() {
		return true
	}

	return false
}

// SetExpirationDeadline gets a reference to the given NullableTime and assigns it to the ExpirationDeadline field.
// Deprecated
func (o *ManagedResource) SetExpirationDeadline(v time.Time) {
	o.ExpirationDeadline.Set(&v)
}

// SetExpirationDeadlineNil sets the value for ExpirationDeadline to be an explicit nil
func (o *ManagedResource) SetExpirationDeadlineNil() {
	o.ExpirationDeadline.Set(nil)
}

// UnsetExpirationDeadline ensures that no value is present for ExpirationDeadline, not even an explicit nil
func (o *ManagedResource) UnsetExpirationDeadline() {
	o.ExpirationDeadline.Unset()
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId.Get()) {
		var ret string
		return ret
	}
	return *o.OwnerId.Get()
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetOwnerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OwnerId.Get(), o.OwnerId.IsSet()
}

// HasOwnerId returns a boolean if a field has been set.
func (o *ManagedResource) HasOwnerId() bool {
	if o != nil && o.OwnerId.IsSet() {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given NullableString and assigns it to the OwnerId field.
func (o *ManagedResource) SetOwnerId(v string) {
	o.OwnerId.Set(&v)
}

// SetOwnerIdNil sets the value for OwnerId to be an explicit nil
func (o *ManagedResource) SetOwnerIdNil() {
	o.OwnerId.Set(nil)
}

// UnsetOwnerId ensures that no value is present for OwnerId, not even an explicit nil
func (o *ManagedResource) UnsetOwnerId() {
	o.OwnerId.Unset()
}

// GetInternalState returns the InternalState field value if set, zero value otherwise.
func (o *ManagedResource) GetInternalState() ResourceState {
	if o == nil || IsNil(o.InternalState) {
		var ret ResourceState
		return ret
	}
	return *o.InternalState
}

// GetInternalStateOk returns a tuple with the InternalState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetInternalStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.InternalState) {
		return nil, false
	}
	return o.InternalState, true
}

// HasInternalState returns a boolean if a field has been set.
func (o *ManagedResource) HasInternalState() bool {
	if o != nil && !IsNil(o.InternalState) {
		return true
	}

	return false
}

// SetInternalState gets a reference to the given ResourceState and assigns it to the InternalState field.
func (o *ManagedResource) SetInternalState(v ResourceState) {
	o.InternalState = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *ManagedResource) GetState() ResourceState {
	if o == nil || IsNil(o.State) {
		var ret ResourceState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *ManagedResource) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given ResourceState and assigns it to the State field.
func (o *ManagedResource) SetState(v ResourceState) {
	o.State = &v
}

// GetLastStateChangeTime returns the LastStateChangeTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetLastStateChangeTime() time.Time {
	if o == nil || IsNil(o.LastStateChangeTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastStateChangeTime.Get()
}

// GetLastStateChangeTimeOk returns a tuple with the LastStateChangeTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetLastStateChangeTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastStateChangeTime.Get(), o.LastStateChangeTime.IsSet()
}

// HasLastStateChangeTime returns a boolean if a field has been set.
func (o *ManagedResource) HasLastStateChangeTime() bool {
	if o != nil && o.LastStateChangeTime.IsSet() {
		return true
	}

	return false
}

// SetLastStateChangeTime gets a reference to the given NullableTime and assigns it to the LastStateChangeTime field.
func (o *ManagedResource) SetLastStateChangeTime(v time.Time) {
	o.LastStateChangeTime.Set(&v)
}

// SetLastStateChangeTimeNil sets the value for LastStateChangeTime to be an explicit nil
func (o *ManagedResource) SetLastStateChangeTimeNil() {
	o.LastStateChangeTime.Set(nil)
}

// UnsetLastStateChangeTime ensures that no value is present for LastStateChangeTime, not even an explicit nil
func (o *ManagedResource) UnsetLastStateChangeTime() {
	o.LastStateChangeTime.Unset()
}

// GetValidityLimit returns the ValidityLimit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetValidityLimit() time.Time {
	if o == nil || IsNil(o.ValidityLimit.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ValidityLimit.Get()
}

// GetValidityLimitOk returns a tuple with the ValidityLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetValidityLimitOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ValidityLimit.Get(), o.ValidityLimit.IsSet()
}

// HasValidityLimit returns a boolean if a field has been set.
func (o *ManagedResource) HasValidityLimit() bool {
	if o != nil && o.ValidityLimit.IsSet() {
		return true
	}

	return false
}

// SetValidityLimit gets a reference to the given NullableTime and assigns it to the ValidityLimit field.
func (o *ManagedResource) SetValidityLimit(v time.Time) {
	o.ValidityLimit.Set(&v)
}

// SetValidityLimitNil sets the value for ValidityLimit to be an explicit nil
func (o *ManagedResource) SetValidityLimitNil() {
	o.ValidityLimit.Set(nil)
}

// UnsetValidityLimit ensures that no value is present for ValidityLimit, not even an explicit nil
func (o *ManagedResource) UnsetValidityLimit() {
	o.ValidityLimit.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ManagedResource) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ManagedResource) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *ManagedResource) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *ManagedResource) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *ManagedResource) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *ManagedResource) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *ManagedResource) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ManagedResource) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *ManagedResource) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *ManagedResource) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o ManagedResource) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ManagedResource) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.JsonSchemaId) {
		toSerialize["jsonSchemaId"] = o.JsonSchemaId
	}
	if o.AdministratorsId.IsSet() {
		toSerialize["administratorsId"] = o.AdministratorsId.Get()
	}
	toSerialize["resourceIdentifier"] = o.ResourceIdentifier
	toSerialize["displayName"] = o.DisplayName
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	toSerialize["managedResourceType"] = o.ManagedResourceType
	if !IsNil(o.Owner) {
		toSerialize["owner"] = o.Owner
	}
	if !IsNil(o.Administrators) {
		toSerialize["administrators"] = o.Administrators
	}
	if !IsNil(o.ResourceCategory) {
		toSerialize["resourceCategory"] = o.ResourceCategory
	}
	if !IsNil(o.Reassignable) {
		toSerialize["reassignable"] = o.Reassignable
	}
	if !IsNil(o.AutoReassign) {
		toSerialize["autoReassign"] = o.AutoReassign
	}
	if !IsNil(o.PendingAction) {
		toSerialize["pendingAction"] = o.PendingAction
	}
	if !IsNil(o.Disabled) {
		toSerialize["disabled"] = o.Disabled
	}
	if !IsNil(o.Blocked) {
		toSerialize["blocked"] = o.Blocked
	}
	if !IsNil(o.SecurityIssues) {
		toSerialize["securityIssues"] = o.SecurityIssues
	}
	if o.BlockingReason.IsSet() {
		toSerialize["blockingReason"] = o.BlockingReason.Get()
	}
	if o.BlockingTime.IsSet() {
		toSerialize["blockingTime"] = o.BlockingTime.Get()
	}
	if o.BlockingDeadline.IsSet() {
		toSerialize["blockingDeadline"] = o.BlockingDeadline.Get()
	}
	if o.ArchiveDeadline.IsSet() {
		toSerialize["archiveDeadline"] = o.ArchiveDeadline.Get()
	}
	if o.DeleteDeadline.IsSet() {
		toSerialize["deleteDeadline"] = o.DeleteDeadline.Get()
	}
	if o.ExpirationDeadline.IsSet() {
		toSerialize["expirationDeadline"] = o.ExpirationDeadline.Get()
	}
	if o.OwnerId.IsSet() {
		toSerialize["ownerId"] = o.OwnerId.Get()
	}
	if !IsNil(o.InternalState) {
		toSerialize["internalState"] = o.InternalState
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if o.LastStateChangeTime.IsSet() {
		toSerialize["lastStateChangeTime"] = o.LastStateChangeTime.Get()
	}
	if o.ValidityLimit.IsSet() {
		toSerialize["validityLimit"] = o.ValidityLimit.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *ManagedResource) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"resourceIdentifier",
		"displayName",
		"managedResourceType",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varManagedResource := _ManagedResource{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varManagedResource)

	if err != nil {
		return err
	}

	*o = ManagedResource(varManagedResource)

	return err
}

type NullableManagedResource struct {
	value *ManagedResource
	isSet bool
}

func (v NullableManagedResource) Get() *ManagedResource {
	return v.value
}

func (v *NullableManagedResource) Set(val *ManagedResource) {
	v.value = val
	v.isSet = true
}

func (v NullableManagedResource) IsSet() bool {
	return v.isSet
}

func (v *NullableManagedResource) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableManagedResource(val *ManagedResource) *NullableManagedResource {
	return &NullableManagedResource{value: val, isSet: true}
}

func (v NullableManagedResource) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableManagedResource) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
